﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.EJ2;
using Syncfusion.EJ2.Navigations;

namespace RemoteData.Controllers
{

    public class TreeviewController: Controller
    {
        public class Country
        {
            public string id { get; set; }
            public string name { get; set; }
            public List<State> child { get; set; }
            public Dictionary<string, string> htmlAttribute { get; internal set; }
        }

        public class State
        {
            public string id { get; set; }
            public string name { get; set; }
            public List<City> child { get; set; }
            public Dictionary<string, string> htmlAttribute = new Dictionary<string, string>();
        }

        public class City
        {
            public string id { get; set; }
            public string name { get; set; }
            public Dictionary<string, string> htmlAttribute = new Dictionary<string, string>();


        }


        List<Country> Countries;
        List<State> States;
        List<City> Cities;
     

        public List<Country> TemplateData
        {
            get
            {
                if (Countries == null)
                    InitializeTempateData();
                return Countries;
            }
        }

        private void InitializeTempateData()
        {
            Countries = new List<Country>();
            States = new List<State>();
            Cities= new List<City>();
            List<City> Cities1 = new List<City>();
            List<City> Cities2 = new List<City>();
            List<City> Cities3 = new List<City>();
            List<City> Cities4 = new List<City>();
            List<City> Cities5 = new List<City>();
            List<City> Cities6 = new List<City>();
            List<City> Cities7 = new List<City>();
            List<City> Cities8 = new List<City>();
            Countries.Add(new Country { id = "1", name = "Australia", child = States,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-1" } }
            });
            States.Add(new State { id = "2", name = "New South Wales", child = Cities,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities.Add(new City { id = "17", name = "Hunter Region",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities.Add(new City { id = "18", name = "Northern Rivers" ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities.Add(new City { id = "19", name = "Mid North Coast", htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } } });
            List<State> State1 = new List<State>();
            States.Add(new State { id = "3", name = "South Australia", child = Cities1,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities1.Add(new City { id = "20", name = "Adelaide",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities1.Add(new City { id = "21", name = "Clare valley",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities1.Add(new City { id = "22", name = "Flienders Rangers Council" ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            States.Add(new State { id = "4", name = "Queensland", child = Cities2 ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities2.Add(new City { id = "23", name = "Central Queensland",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities2.Add(new City { id = "24", name = "Wide Bay–Burnett." ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities2.Add(new City { id = "25", name = "South East Queensland" ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Countries.Add(new Country { id = "5", name = "India", child = State1,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-1" } }
            });
            State1.Add(new State { id = "6", name = "Assam", child = Cities3,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities3.Add(new City { id = "7", name = "Cachar",

                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities3.Add(new City { id = "8", name = "Nagaon",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities3.Add(new City { id = "9", name = "Jorhat",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            State1.Add(new State { id = "10", name = "TamilNadu", child = Cities4,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities4.Add(new City { id = "14", name = "Chennai",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities4.Add(new City { id = "15", name = "Coimbatore" ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities4.Add(new City { id = "16", name = "Madurai",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            State1.Add(new State { id = "11", name = "Kerala", child = Cities5,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities5.Add(new City { id = "12", name = "Alappuzha",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities5.Add(new City { id = "13", name = "Wayanad",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities5.Add(new City { id = "26", name = "Kannur",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            List<State> State2 = new List<State>();
            Countries.Add(new Country { id = "27", name = "Brazil", child = State2 ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-1" } }
            });
            State2.Add(new State { id = "28", name = "Paraná", child = Cities6,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            State2.Add(new State { id = "29", name = "Ceará", child = Cities7,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            State2.Add(new State { id = "30", name = "Acre", child = Cities8 ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-2" } }
            });
            Cities6.Add(new City { id = "31", name = "Curitiba",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities6.Add(new City { id = "32", name = "Londrina" ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities6.Add(new City { id = "33", name = "Rio de Janeiro",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities7.Add(new City { id = "34", name = "Fortaleza",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities7.Add(new City { id = "35", name = "‎Sobral",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities7.Add(new City { id = "36", name = "‎Roraima",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities8.Add(new City { id = "37", name = "Tocantins",
            
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities8.Add(new City { id = "38", name = "Alagoas",
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
            Cities8.Add(new City { id = "39", name = "Rondônia" ,
                htmlAttribute = new Dictionary<string, string>() { { "data-type", "level-3" } }
            });
        }

        [HttpGet]
        [HttpPost]
        [ActionName("GetAllData")]
        public IEnumerable<Country> GetAllData()
        {
            return TemplateData;
        }
    }
}
